package android.acapelagroup.acapelacloud_android_demo;

import androidx.appcompat.app.AppCompatActivity;

import android.Manifest;
import android.content.Context;
import android.content.pm.PackageManager;
import android.media.AudioAttributes;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


public class MainActivity extends AppCompatActivity {

	// Fill with your credentials
    String email = "";
    String password = "";

    Spinner spinner_tts_voice = null;
    EditText edittext_text = null;
    Button button_speak = null;
    Button button_audiofile = null;
    Button button_stop = null;
    Button button_pause = null;
    Button button_resume = null;


    EditText edittext_account = null;

    MediaPlayer mediaplayer;

    Context applicationcontext;

    String token = "";


    ArrayList<String> voicesList = new ArrayList<String>();


    // Permissions needed
    public static String[] permissions_list = new String[] {
            Manifest.permission.WRITE_EXTERNAL_STORAGE,
            Manifest.permission.INTERNET
    };


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        applicationcontext = this;

        spinner_tts_voice = (Spinner) findViewById(R.id.spinner_tts_voice);

        edittext_text = (EditText) findViewById(R.id.edittext_text);

        edittext_text.setText("Hello, I'm speaking with the Acapela Cloud online service");

        edittext_account = (EditText) findViewById(R.id.edittext_account);
        edittext_account.setEnabled(false);

        button_stop  = (Button) findViewById(R.id.button_stop);
        button_speak = (Button) findViewById(R.id.button_speak);
        button_pause = (Button) findViewById(R.id.button_pause);
        button_resume = (Button) findViewById(R.id.button_resume);
        button_audiofile = (Button) findViewById(R.id.button_audiofile);

        button_speak.setOnClickListener(new clicker());
        button_stop.setOnClickListener(new clicker());
        button_pause.setOnClickListener(new clicker());
        button_resume.setOnClickListener(new clicker());
        button_audiofile.setOnClickListener(new clicker());

        mediaplayer = new MediaPlayer();
        mediaplayer.setAudioStreamType(AudioManager.STREAM_MUSIC);


        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {

            // check permissions in runtime mode for the latest android version
            if (arePermissionsEnabled()) {

                Thread thread = new Thread() {
                    @Override
                    public void run() {
                        token = login(email, password);
                        final String account_info = account_info(token);

                        runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                edittext_account.setText(account_info);

                            }
                        });
                        set_voice_list();
                    }
                };

                thread.start();
            } else {
                requestMultiplePermissions();
            }

        } else {

            Thread thread = new Thread() {
                @Override
                public void run() {
                token = login(email,password);
                final String account_info = account_info(token);

                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        edittext_account.setText(account_info);

                    }
                });
                set_voice_list();
                }
            };

            thread.start();
        }

    }


    //----------------------------------------------------------
    // Runtime Permissions for android > api 21
    //----------------------------------------------------------

    public boolean arePermissionsEnabled(){
        for(String permission : permissions_list){
            if(checkSelfPermission(permission) != PackageManager.PERMISSION_GRANTED)
                return false;
        }
        return true;
    }

    private void requestMultiplePermissions(){
        List<String> remainingPermissions = new ArrayList<>();
        for (String permission : permissions_list) {
            if (checkSelfPermission(permission) != PackageManager.PERMISSION_GRANTED) {
                remainingPermissions.add(permission);
            }
        }
        requestPermissions(remainingPermissions.toArray(new String[remainingPermissions.size()]), 101);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if(requestCode == 101){
            for(int i=0;i<grantResults.length;i++){
                if(grantResults[i] != PackageManager.PERMISSION_GRANTED){
                    return;
                }
            }
        }
    }


    class clicker implements Button.OnClickListener {
        public void onClick(View v) {
            String voice = (String) spinner_tts_voice.getSelectedItem();
            String text = edittext_text.getText().toString();

            switch (v.getId()) {

                case R.id.button_speak:
                    speak(token,voice,text);
                    break;

                case R.id.button_audiofile:
                    generate_audio_file(token,voice,text);
                    break;


                case R.id.button_stop:
                    stop();
                    break;

                case R.id.button_pause:
                    mediaplayer.pause();
                    break;

                case R.id.button_resume:
                    mediaplayer.start();
                    break;

            }
        }
    }


    public void set_voice_list() {

        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                String[] voiceListArray = new String[voicesList.size()];
                voiceListArray = voicesList.toArray(voiceListArray);
                ArrayAdapter<Object> voice_adapter = new ArrayAdapter<Object>(applicationcontext, android.R.layout.simple_spinner_item, voiceListArray);
                voice_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                spinner_tts_voice.setAdapter(voice_adapter);

            }
        });
    }

    //----------------------------------------------------------
    // Acapela Cloud API requests
    //----------------------------------------------------------

    public String login(String email, String password)  {

        HashMap<String, String> params = new HashMap<String, String>();
        params.put("email", email);
        params.put("password", password);

        try {

            URL urlObj = new URL("https://www.acapela-cloud.com/api/login/");
            HttpURLConnection connection = (HttpURLConnection) urlObj.openConnection();
            connection.setRequestMethod("POST");
            connection.setDoInput(true);
            connection.setDoOutput(true);

            OutputStream os = connection.getOutputStream();
            BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
            writer.write(formatPostParams(params));

            writer.flush();
            writer.close();
            os.close();

            int responseCode = connection.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {

                BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                StringBuffer sb = new StringBuffer("");
                String line = "";

                while((line = in.readLine()) != null) {
                    sb.append(line);
                }

                in.close();
                String responseBody = sb.toString();

                JSONObject jsonResponse = new JSONObject(responseBody);
                String token = jsonResponse.getString("token");
                return token;

            }

        } catch(ProtocolException e){
            e.printStackTrace();
        } catch(IOException e){
            e.printStackTrace();
        }catch(Exception e){
            e.printStackTrace();
        }

        return "";
    }


    public String account_info(String token)  {

        try {

            URL urlObj = new URL("https://www.acapela-cloud.com/api/account/");
            HttpURLConnection connection = (HttpURLConnection) urlObj.openConnection();
            connection.setRequestMethod("GET");
            connection.setRequestProperty("Authorization", "Token " + token);
            connection.setDoInput(true);


            int responseCode = connection.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {

                BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                StringBuffer sb = new StringBuffer("");
                String line = "";

                while((line = in.readLine()) != null) {
                    sb.append(line);
                }

                in.close();
                String responseBody = sb.toString();

                JSONObject jsonResponse = new JSONObject(responseBody);
                Iterator<String> keys = jsonResponse.keys();

                String account_info = "";

                while(keys.hasNext()) {
                    String key = keys.next();
                    if (key.contentEquals("voices") == false) {
                        account_info += key + " : " + jsonResponse.get(key) + "\n";
                    }
                }




                voicesList = new ArrayList<String>();
                JSONArray jArray = jsonResponse.getJSONArray("voices");
                int voicesCount = jArray.length();
                for (int i = 0; i < voicesCount; i++) {
                    JSONObject jVoice = jArray.getJSONObject(i);
                    if (jVoice.has("name")) {
                        voicesList.add(jVoice.getString("name"));
                    }
                }

                return account_info;

            }

        } catch(ProtocolException e){
            e.printStackTrace();
        } catch(IOException e){
            e.printStackTrace();
        } catch(Exception e){
            e.printStackTrace();
        }

        return "";
    }

    public void generate_audio_file(final String token, final String voice , final String text) {


        Thread thread = new Thread() {
            @Override
            public void run() {
            Uri.Builder builder = new Uri.Builder();
            builder.scheme("https")
                    .authority("www.acapela-cloud.com")
                    .appendPath("api")
                    .appendPath("command")
                    .appendQueryParameter("output", "stream")
                    .appendQueryParameter("voice", voice)
                    .appendQueryParameter("type", "mp3")
                    .appendQueryParameter("text", text)
                    .appendQueryParameter("token", token);

            String url = builder.build().toString();

            try {

                URL urlObj = new URL(url);
                HttpURLConnection connection = (HttpURLConnection) urlObj.openConnection();
                connection.setRequestMethod("GET");
                connection.setDoInput(true);

                int responseCode = connection.getResponseCode();
                if (responseCode == HttpURLConnection.HTTP_OK) {

                    File file = new File("/sdcard/audio.mp3");
                    OutputStream output = new FileOutputStream(file) ;
                    byte[] buffer = new byte[1024];
                    int read;

                    while ((read = connection.getInputStream().read(buffer)) != -1) {
                        output.write(buffer, 0, read);
                    }
                    output.flush();
                    output.close();
                }

            } catch (IllegalArgumentException e) {
                e.printStackTrace();
            } catch (SecurityException e) {
                e.printStackTrace();
            } catch (IllegalStateException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }

            }
        };

        thread.start();



        return;

    }



    public void speak(String token, String voice , String text) {

        mediaplayer.reset();

        Uri.Builder builder = new Uri.Builder();
        builder.scheme("https")
                .authority("www.acapela-cloud.com")
                .appendPath("api")
                .appendPath("command")
                .appendQueryParameter("output", "stream")
                .appendQueryParameter("voice", voice)
                .appendQueryParameter("type", "mp3")
                .appendQueryParameter("text", text)
                .appendQueryParameter("token", token);

        String url = builder.build().toString();

        try {

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                mediaplayer.setAudioAttributes(new AudioAttributes.Builder()
                        .setUsage(AudioAttributes.USAGE_MEDIA)
                        .setContentType(AudioAttributes.CONTENT_TYPE_MUSIC)
                        .setLegacyStreamType(AudioManager.STREAM_MUSIC)
                        .build());
            } else {
                mediaplayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
            }

            mediaplayer.setDataSource(url);
            mediaplayer.prepare();
            mediaplayer.start();

        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (SecurityException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }


        return;

    }

    public void stop() {
        mediaplayer.stop();
        return;

    }

    private String formatPostParams(HashMap<String, String> params) throws UnsupportedEncodingException {
        StringBuilder result = new StringBuilder();
        boolean first = true;
        for(Map.Entry<String, String> entry : params.entrySet()){
            if (first)
                first = false;
            else
                result.append("&");

            result.append(URLEncoder.encode(entry.getKey(), "UTF-8"));
            result.append("=");
            result.append(URLEncoder.encode(entry.getValue(), "UTF-8"));
        }

        return result.toString();
    }






}
